MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0029249Open CASCADE[OCCT] OCCT:Configurationpublic2017-10-19 14:032018-06-29 21:19
Reporterkgv 
Assigned Tobugmaster 
PrioritynormalSeverityminor 
StatusclosedResolutionfixed 
PlatformWindowsOSVC++ 2013OS Version64 bit
Product Version[OCCT] 7.2.0 
Target Version[OCCT] 7.3.0Fixed in Version[OCCT] 7.3.0 
Summary0029249: Configuration - Standard_Failure compilation fails on VS2013 + Intel Compiler due to unavailability of thread_local
Description
1>  Standard_Failure.cxx
1>C:\OCCT\src\Standard\Standard_Failure.cxx(81): error # 303: explicit type is missing ("int" 
assumed)
1>    static Standard_THREADLOCAL Handle(Standard_Failure) RaisedError;


> "c:\Program Files\CMake\bin\cmake" -G "Visual Studio 12 2013 Win64" -T "Intel C++ Compiler 17.0"

From Intel documentation:
> N2659 Thread-local storage:
> Yes on Linux/OS X, Yes on Windows in VS2015 mode
> [Version 15.0*1 & Later].
https://software.intel.com/en-us/articles/c0x-features-supported-by-intel-c-compiler [^]

Within Standard_Failure.cxx:
#elif (defined(__INTEL_COMPILER) && __INTEL_COMPILER > 1400) || \
      (defined(_MSC_VER) && _MSC_VER >= 1900) /* MSVC++ >= 14 */ || \
      (defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 
8))) /* GCC >= 4.8 */
  #define Standard_THREADLOCAL thread_local

So, I suppose that Intel Compiler relies on features of MSVC C++ Runtime libraries, and thread_local is available only within VS2015+.

Thus, the compiler check should be corrected somehow...

TagsNo tags attached.
Test case numberNot required
Attached Files

- Relationships
child of 0028217closedapn Community Error handling is not thread safe and causing memory corruption and sporadic crashes 

-  Notes
(0071728)
git (administrator)
2017-10-24 11:21

Branch CR29249 has been created by kgv.

SHA-1: 4c4ff4a6a208c53f894ec52594f3c87f7d85f2d5


Detailed log of new commits:

Author: kgv
Date: Tue Oct 24 11:21:03 2017 +0300

    0029249: Configuration - Standard_Failure compilation fails on VS2013 + Intel Compiler due to unavailability of thread_local
    
    Check __INTEL_COMPILER version in combination with _MSC_VER on Windows.
(0071729)
kgv (developer)
2017-10-24 11:21

Please check compilation using Intel compiler (and other compilers).
(0072076)
git (administrator)
2017-11-08 18:24

Branch CR29249 has been deleted by kgv.

SHA-1: 4c4ff4a6a208c53f894ec52594f3c87f7d85f2d5

- Related Changesets
occt: master 777ca20a
Timestamp: 2017-10-24 08:21:03
Author: kgv
Committer: bugmaster
Details ] Diff ]
0029249: Configuration - Standard_Failure compilation fails on VS2013 + Intel Compiler due to unavailability of thread_local

Check __INTEL_COMPILER version in combination with _MSC_VER on Windows.
mod - src/Standard/Standard_Failure.cxx Diff ] File ]

- Issue History
Date Modified Username Field Change
2017-10-19 14:03 kgv New Issue
2017-10-19 14:03 kgv Assigned To => bugmaster
2017-10-19 14:03 kgv Assigned To bugmaster => abv
2017-10-19 14:03 kgv Relationship added related to 0029198
2017-10-19 14:04 kgv Relationship added child of 0028217
2017-10-24 11:21 git Note Added: 0071728
2017-10-24 11:21 kgv Note Added: 0071729
2017-10-24 11:21 kgv Assigned To abv => bugmaster
2017-10-24 11:21 kgv Status new => feedback
2017-11-02 18:34 bugmaster Changeset attached => occt master 777ca20a
2017-11-02 18:34 bugmaster Status feedback => verified
2017-11-02 18:34 bugmaster Resolution open => fixed
2017-11-08 18:24 git Note Added: 0072076
2017-12-12 10:35 bugmaster Test case number => Not required
2018-06-29 21:15 user533 Fixed in Version => 7.3.0
2018-06-29 21:19 user533 Status verified => closed


Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker